-- Emm Decisions
-- Author: Kobe
-- DateCreated: 12/31/2018 1:46:10 PM
--------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------
-- Ylisse: Public Parade
--------------------------------------------------------------------------------------------------------------------------
local Decisions_YlisseParade = {}
    Decisions_YlisseParade.Name = "TXT_KEY_DECISIONS_EMM_YLISSE_PARADE"
	Decisions_YlisseParade.Desc = "TXT_KEY_DECISIONS_EMM_YLISSE_PARADE_DESC"
	HookDecisionCivilizationIcon(Decisions_YlisseParade, "CIVILIZATION_YLISSE")
	Decisions_YlisseParade.CanFunc = (
	function(pPlayer)
		if pPlayer:GetCivilizationType() ~= GameInfoTypes.CIVILIZATION_YLISSE then return false, false end
		
		if load(pPlayer, "Decisions_YlisseParade") ~= nil then
			if load(pPlayer, "Decisions_YlisseParade") >= pPlayer:GetCurrentEra() then
				Decisions_YlisseParade.Desc = Locale.ConvertTextKey("TXT_KEY_DECISIONS_EMM_YLISSE_PARADE_ENACTED_DESC")
				return false, false, true
			end
		end
			
		local iCost = math.floor(150 * (1 + pPlayer:GetCurrentEra()) * iMod)
		Decisions_YlisseParade.Desc = Locale.ConvertTextKey("TXT_KEY_DECISIONS_EMM_YLISSE_PARADE_DESC", iCost)
		
		if (pPlayer:GetGold() < iCost) then return true, false end
		if (pPlayer:GetNumResourceAvailable(iMagistrate, false) < 1) then return true, false end
		
		return true, true
	end
	)
	
	Decisions_YlisseParade.DoFunc = (
	function(pPlayer)
		local iCost = math.ceil(150 * iMod)
		pPlayer:ChangeGold(-iCost)
		pPlayer:ChangeNumResourceTotal(iMagistrate, -1)

		pPlayer:SetNumFreePolicies(1)
		pPlayer:SetNumFreePolicies(0)
		pPlayer:SetHasPolicy(GameInfoTypes.POLICY_YLISSE_DECISION, true)
		
		save(pPlayer, "Decisions_YlisseParade", pPlayer:GetCurrentEra())
	end
	)
	
Decisions_AddCivilisationSpecific(GameInfoTypes.CIVILIZATION_YLISSE, "Decisions_YlisseParade", Decisions_YlisseParade)